
/*  Various programs concerning the El-Fish .fsh file format.
    Copyright (C) 2004 Vidar Holen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


package holen.vidar.elfish;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;

public class Swim extends JFrame implements KeyListener {
    ArrayList anim;
    int scale=4;
    int push=0;
    int count=0;
    int way=1;
    int delay=500;
    int num=0;
    boolean pong=false, stop=false;
    Fish fish;

    public Swim(String args) throws Exception {
        super("Fishy");
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        fish=Fish.loadFish(args);

        anim=new ArrayList();
        int[] anims=
        {310,30,00,10,120,230,200,208,210,330,300,308};  
        for(int i=0; i<anims.length; i++) {
            int f=anims[i]%10;
            anims[i]/=10;

            int d=anims[i]/10;
            int s=anims[i]%10;

            switch(f) {
                case 0:
                    anim.addAll(fish.getSequence(d,s));
                    break;
                case 1:
                    for(int j=1; j<fish.getSequence(d,s).size(); j++)
                        anim.add(fish.getSequence(d,s).get(j));
                    break;
                case 8:
                    for(int j=fish.getSequence(d,s).size()-2; j>=0; j--)
                        anim.add(fish.getSequence(d,s).get(j));
                    break;
                case 9:
                    for(int j=fish.getSequence(d,s).size()-1; j>=0; j--)
                        anim.add(fish.getSequence(d,s).get(j));
                    break;
            } 
        }
        System.out.println("cow: "+anim.size());
        
        addKeyListener(this);
        setSize(320,240);
        setVisible(true);

        new Thread() {
            public void run() {
                while(true) {
                    try {
                        Thread.sleep(delay);
                        repaint();
                    } catch(Exception e) {}
                }
            }
        }.start();
    }
    
    public void keyPressed(KeyEvent e) {
        boolean m=false;
        if(e.getKeyCode()==e.VK_A) scale++;
        else if(e.getKeyCode()==e.VK_Z) scale--;
        else if(e.getKeyCode()==e.VK_SPACE) stop=!stop;
        else if(e.getKeyCode()==e.VK_ENTER) pong=!pong;
        else if(e.getKeyCode()==e.VK_UP) delay+=50;
        else if(e.getKeyCode()==e.VK_DOWN) delay-=40;
        else if(e.getKeyCode()==e.VK_LEFT) { num--; m=true; }
        else if(e.getKeyCode()==e.VK_RIGHT) { num++; m=true; }
        if(m) {
            anim=fish.getRaw(num);
            System.out.println("Selected: "+((FishFrame)anim.get(0)).rawframe);
            count=0;
            way=1;
        }

        System.out.println("Pong: "+pong+", "+num+", d="+delay);
    }
    public void keyTyped(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}
    public void paint(Graphics g) {
        FishFrame ff=((FishFrame)anim.get(count));
        g.clearRect(0,0,getWidth(),getHeight());
        g.drawImage(ff.img,ff.x*scale,30+ff.y*scale,ff.img.getWidth(null)*scale,ff.img.getHeight(null)*scale,null);
        if(stop) return;
        
        System.out.println(count+": "+ff.x+","+ff.y);
        count+=way;
        if(count>=anim.size() || count<0) {
            count-=way;
            if(pong) {
                way*=-1;
                count+=way;
            } else {
                way=1;
                count=0;
            }
        }
    }
    public static void main(String[] args) throws Exception {
        Swim s=new Swim(args[0]);
    }
}

